LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.std_logic_unsigned.all;

ENTITY AhGen IS
	PORT (
		clk			: IN  STD_LOGIC;
		rst			: IN  STD_LOGIC;
		power			: IN  STD_LOGIC_VECTOR (15 DOWNTO 0);
		addr 			: IN  STD_LOGIC_VECTOR ( 9 DOWNTO 0);
		wren			: IN  STD_LOGIC;
		addr_out		: OUT STD_LOGIC_VECTOR ( 9 DOWNTO 0);
		data_done	: OUT STD_LOGIC
	);
END AhGen;

ARCHITECTURE logic OF AhGen IS 
signal pdata	: std_logic_vector (15 downto 0);
signal cdata	: std_logic_vector (15 downto 0);
signal paddr	: std_logic_vector ( 9 downto 0);
signal caddr	: std_logic_vector ( 9 downto 0);
	BEGIN
	cdata <= power;
	caddr <= addr;
	addr_out <= paddr;
	PROCESS(clk,paddr) BEGIN
	if (rising_edge(clk)) then
		if rst = '1' or wren = '0'then
			pdata <= (others=>'0');
			paddr <= (others=>'0');			
		elsif (addr > "0000000001") and (addr < "0000100000") and wren = '1' then
				if (pdata < cdata) then
					pdata <= cdata;
					paddr <= caddr;
					data_done <= '0';
				else
					pdata <= pdata;
					paddr <= paddr;
					data_done <= '0';
				end if;
		else 
			data_done <= '1';
		end if;
	end if;

	END PROCESS;
END logic;