library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


entity VR_control is
	port(
		clk		 			: in	std_logic;--this clock should be the clock of sampling data.
		reset	 				: in	std_logic;
		address_in	 		: in	std_logic_vector(10 downto 0);
		address_sel_bit	: out std_logic;
		start	 				: out	std_logic
	);
end entity;


architecture rtl of VR_control is

	type state_type is (s0, s1, s2, s3, s1_1, s3_1);

	signal state   : state_type;
	signal counter : std_logic_vector(7 downto 0);
begin
	-- Logic to advance to the next state
	process (clk, reset)
	begin
		if reset = '1' then
			state <= s0;
			counter <= "00000000";
		elsif (rising_edge(clk)) then
			case state is
				when s0=>
					if address_in = "10000000000" then
						state <= s1;
						counter <= "00000000";
					else
						state <= s0;
					end if;
				when s1=>
--					if counter = "00000000" then
						state <= s1_1;
--						counter <= "00000000";
--					else
--						state <= s1;
--						counter <= counter + '1';
--					end if;
				when s1_1=>
					if counter = "11111111" then
						state <= s2;
						counter <= "00000000";
					else
						state <= s1_1;
					counter <= counter + '1';
					end if;
				when s2=>
					if address_in = "00000000000" then
						state <= s3;
						counter <= "00000000";
					else
						state <= s2;
					end if;
				when s3 =>
--					if counter = "11100000" then
						state <= s3_1;
--						counter <= "00000000";
--					else
--						state <= s3;
--						counter <= counter + '1';
--					end if;
				when s3_1 =>
					if counter = "11111111" then
						state <= s0;
						counter <= "00000000";
					else
						state <= s3_1;
						counter <= counter + '1';
					end if;
			end case;
		end if;
	end process;

	-- Output depends solely on the current state
	process (state)
	begin
		case state is
			when s0 =>
				address_sel_bit <= '0';
				start <= '0';
			when s1 =>
				address_sel_bit <= '0';
				start <= '1';
			when s1_1 =>
				address_sel_bit <= '0';
				start <= '0';
			when s2 =>
				address_sel_bit <= '1';
				start <= '0';
			when s3 =>
				address_sel_bit <= '1';
				start <= '1';
			when s3_1 =>
				address_sel_bit <= '1';
				start <= '0';
		end case;
	end process;

end rtl;
