LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.std_logic_unsigned.all;

ENTITY FFToutControl IS
	PORT (
		clk				: IN  STD_LOGIC;
		reset_n			: IN  STD_LOGIC;
		sink_sop 		: IN  STD_LOGIC;
		source_eop		: IN  STD_LOGIC;
		source_valid	: IN  STD_LOGIC;
		data_in			: IN  STD_LOGIC_VECTOR (15 DOWNTO 0);
		data_out			: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		wren				: OUT STD_LOGIC;
		FFTdone			: OUT STD_LOGIC;
		write_addr		: OUT STD_LOGIC_VECTOR( 9 DOWNTO 0)
	);
END FFToutControl;

ARCHITECTURE logic OF FFToutControl IS
SIGNAL outcount      : STD_LOGIC_VECTOR ( 9 DOWNTO 0);
BEGIN
	write_addr <= outcount;
   PROCESS (Clk)
   BEGIN
      IF (Clk'EVENT AND Clk = '1') THEN
         IF (sink_sop = '1' OR reset_n = '0') THEN
            FFTdone <= '0';
         ELSIF (source_eop = '1') THEN
            FFTdone <= '1';
			ELSE
				FFTdone <= '0';
         END IF;
         
         IF (source_valid = '1') THEN
            IF (outcount < 511) THEN
               wren <= '1';
					data_out <= data_in;
            ELSE
               wren <= '0';
					data_out <= (others => '0');
					END IF;
            
            IF (source_eop = '1') THEN
               outcount <= (others =>'0');
            ELSE
               outcount <= outcount + '1';
            END IF;
         ELSE
            wren <= '0';
         END IF;
      END IF;
   END PROCESS;
END logic;