LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.std_logic_unsigned.all;

ENTITY PowerGen IS
	PORT (
		source_real	: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		source_imag	: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		power_out	: OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
	);
END PowerGen;

ARCHITECTURE connect OF PowerGen IS 

component Power IS
	PORT (
		realAbs		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		imagAbs		: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		power_out	: OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
	);
end component;

component AbsGen IS
	PORT (
		source_real	: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		source_imag	: IN STD_LOGIC_VECTOR (15 DOWNTO 0);
		realAbs		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
		imagAbs		: OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
	);
end component;

   SIGNAL realAbs : STD_LOGIC_VECTOR(15 DOWNTO 0);
   SIGNAL imagAbs : STD_LOGIC_VECTOR(15 DOWNTO 0);
	BEGIN
	AbsoluteValue: AbsGen port map ( source_real, source_imag, realAbs, imagAbs);
	PowerValue: Power port map ( realAbs, imagAbs, power_out);
	
END connect;