module recorder(input clk, input rst, output I2C_SCLK, inout I2C_SDAT,
input AUD_ADCLRCK, input AUD_ADCDAT, input AUD_BCLK, output AUD_XCK,
output [15:0] result, output enable, output [10:0] addr 
);
	//recorder top module
	wire end_sig;
	wire clock_500;
	wire [23:0] data_internal;
	wire go;
	controller control(.clk(clk), .rst(rst), .END(end_sig),
	.clock_500(clock_500),.data(data_internal),.GO(go), .CLOCK_2(AUD_XCK));
	
	i2c i2ccon(.CLOCK(clock_500), .I2C_SCLK(I2C_SCLK), .I2C_SDAT(I2C_SDAT),
	.I2C_DATA(data_internal),
	.GO(go), .END(end_sig),     //END transfor 
	.RESET(1'b1));
	
	s2p s2pcon(.clk(AUD_BCLK), .data(AUD_ADCDAT), .AUD_ADCLRCK(AUD_ADCLRCK), .data_o(result), .enable(enable), .addr(addr));
endmodule
